#!
use Win32::Pipe;
use Win32::SerialPort;

#daemonize();
check_pid();
open (PID_FILE,">C:/windows/temp/resetter.pid");
print PID_FILE $$;
close PID_FILE;

$ob=Win32::SerialPort->new("COM2:");
$ob->baudrate(2400);
$ob->parity("none");
$ob->databits(8);
$ob->stopbits(1);
$ob->handshake("none");
$ob->stty_istrip(0);

while (1) {
 $pipe=new Win32::Pipe("workerpipe");
 $pipe->Connect();
 $line=$pipe->Read();
 $ob->write($line);
 $pipe->Disconnect();

}
undef($ob);


unlink("C:/windows/temp/resetter.pid");

sub daemonize {
chdir 'C:/'		or die "Can't chdir to /: $!";
open STDIN, '>NUL:' or die "Can't read /dev/null: $!";
open STDOUT, '>NUL:'
or die "Can't write to /dev/null: $!";
setsid			or die "Can't start a new session: $!";
open STDERR, '>&STDOUT'	or die "Can't dup stdout: $!";

}


# check_pid - checks if the PID in /tmp/resetter.pid is correct. If not,
# it removes the PID file
sub check_pid {
 open(PID_FILE,"<C:/Windows/temp/resetter.pid") or $child_pid=0;
 $child_pid=<PID_FILE>;
 close(PID_FILE);
 if ($child_pid==0 || (kill 0,$child_pid)==0 ) {
  unlink("C:/Windows/temp/resetter.pid");
  }
 }
